SystemOrganization addCategory: #'Pier-Filing'!

PRVisitor subclass: #PFExporter
	instanceVariableNames: 'path value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFExporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 00:37'!
exportStructure: aStructure to: aFolderPath
	| newName newPath stream |
	newName := aStructure name, '.', aStructure class name.
	(FileDirectory on: aFolderPath) createDirectory: newName.
	newPath := aFolderPath, FileDirectory slash, newName.
	aStructure enumerator do: [:each |
		self exportStructure: each to: newPath ].
	aStructure accept: (self new path: newPath)! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 00:47'!
exportProperty: aProperty of: aStructure
	| stream |
	stream := (FileDirectory on: self path) forceNewFileNamed: aProperty.
	value := (aStructure perform: aProperty asSymbol).
	value ifNotNil: [
		stream nextPutAll: value asString ].
	stream close! !

!PFExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path
	^ path! !

!PFExporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 00:35'!
path: anObject
	path := anObject! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 00:42'!
visitBlog: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportProperty: 'tags' of: aStructure.
	self exportProperty: 'copyright' of: aStructure.
	self exportProperty: 'language' of: aStructure.! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 00:56'!
visitCase: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportProperty: 'tags' of: aStructure.! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 01:05'!
visitFile: aStructure
	self exportProperty: 'contents' of: aStructure.
! !

!PFExporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 00:42'!
visitPost: aStructure
	self exportProperty: 'contents' of: aStructure.
	self exportProperty: 'tags' of: aStructure.
	self exportProperty: 'author' of: aStructure.
	self exportProperty: 'publication' of: aStructure.! !

PRVisitor subclass: #PFImporter
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Filing'!

!PFImporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 01:45'!
import: aDirectory
	| structure |
	structure := PRPage named: 'root'.
	self import: aDirectory into: structure.
	^ structure childrenDecoration children first
		instVarNamed: 'parent' put: nil;
		yourself! !

!PFImporter class methodsFor: 'as yet unclassified' stamp: 'tg 11/3/2009 02:35'!
import: aPath into: aStructure
	| newName typeName newStruct directory |
	directory := FileDirectory on: aPath.
	newName := (directory localName subStrings: '.') first.
	typeName := (aPath subStrings: '.') last.
	newStruct := (Smalltalk at: typeName asSymbol) named: newName.
	newStruct accept: (self new path: directory; yourself).
	directory directoryNames do: [ :each |
		self import: (aPath, FileDirectory slash, each) into: newStruct ].
	aStructure addChild: newStruct! !

!PFImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path
	^ path! !

!PFImporter methodsFor: 'accessing' stamp: 'tg 11/3/2009 02:32'!
path: anObject
	path := anObject! !

!PFImporter methodsFor: 'private' stamp: 'tg 11/3/2009 02:36'!
read: aString in: aDirectory do: aBlock
	| stream |
	stream := aDirectory oldFileNamed: aString.
	^ [ aBlock value: stream ] ensure: [ stream close ]! !

!PFImporter methodsFor: 'visiting' stamp: 'tg 11/3/2009 02:37'!
visitCase: aStructure
	self path fileNames do: [ :each |
		self read: each in: self path do: [:stream |
			aStructure perform: (each, ':') asSymbol with: stream contents]
		].! !
